Package com.sun.mail.imap

## Class IMAPBodyPart

- java.lang.Object
- - javax.mail.BodyPart
  - - javax.mail.internet.MimeBodyPart
    - - com.sun.mail.imap.IMAPBodyPart

All Implemented Interfaces:
  `ReadableMime`, `MimePart`, `Part`

    public class IMAPBodyPart
    extends MimeBodyPart
    implements ReadableMime

An IMAP body part.

Author:
  John Mani, Bill Shannon

### Field Summary

### Fields inherited from class javax.mail.internet.MimeBodyPart

`cachedContent, content, contentStream, dh, headers`

### Fields inherited from class javax.mail.BodyPart

`parent`

### Fields inherited from interface javax.mail.Part

`ATTACHMENT, INLINE`

### Constructor Summary

Constructors
`protected` `IMAPBodyPart​(BODYSTRUCTURE bs, java.lang.String sid, IMAPMessage message)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addHeader​(java.lang.String name, java.lang.String value)` Add this value to the existing values for this header_name.
`void` `addHeaderLine​(java.lang.String line)` Add a header line to this body part
`java.util.Enumeration<java.lang.String>` `getAllHeaderLines()` Get all header lines as an Enumeration of Strings.
`java.util.Enumeration<Header>` `getAllHeaders()` Return all the headers from this Message as an Enumeration of Header objects.
`java.lang.String` `getContentID()` Returns the value of the "Content-ID" header field.
`java.lang.String` `getContentMD5()` Return the value of the "Content-MD5" header field.
`protected java.io.InputStream` `getContentStream()` Produce the raw bytes of the content.
`java.lang.String` `getContentType()` Returns the value of the RFC 822 "Content-Type" header field.
`javax.activation.DataHandler` `getDataHandler()` Return a DataHandler for this body part's content.
`java.lang.String` `getDescription()` Returns the "Content-Description" header field of this body part.
`java.lang.String` `getDisposition()` Returns the disposition from the "Content-Disposition" header field.
`java.lang.String` `getEncoding()` Returns the content transfer encoding from the "Content-Transfer-Encoding" header field.
`java.lang.String` `getFileName()` Get the filename associated with this body part.
`java.lang.String[]` `getHeader​(java.lang.String name)` Get all the headers for this header_name.
`int` `getLineCount()` Return the number of lines for the content of this Part.
`java.util.Enumeration<java.lang.String>` `getMatchingHeaderLines​(java.lang.String[] names)` Get matching header lines as an Enumeration of Strings.
`java.util.Enumeration<Header>` `getMatchingHeaders​(java.lang.String[] names)` Return matching headers from this Message as an Enumeration of Header objects.
`java.io.InputStream` `getMimeStream()` Return the MIME format stream corresponding to this message part.
`java.util.Enumeration<java.lang.String>` `getNonMatchingHeaderLines​(java.lang.String[] names)` Get non-matching header lines as an Enumeration of Strings.
`java.util.Enumeration<Header>` `getNonMatchingHeaders​(java.lang.String[] names)` Return non-matching headers from this Message as an Enumeration of Header objects.
`int` `getSize()` Return the size of the content of this body part in bytes.
`void` `removeHeader​(java.lang.String name)` Remove all headers with this name.
`void` `setContent​(java.lang.Object o, java.lang.String type)` A convenience method for setting this body part's content.
`void` `setContent​(Multipart mp)` This method sets the body part's content to a Multipart object.
`void` `setContentMD5​(java.lang.String md5)` Set the "Content-MD5" header field of this body part.
`void` `setDataHandler​(javax.activation.DataHandler content)` This method provides the mechanism to set this body part's content.
`void` `setDescription​(java.lang.String description, java.lang.String charset)` Set the "Content-Description" header field for this body part.
`void` `setDisposition​(java.lang.String disposition)` Set the disposition in the "Content-Disposition" header field of this body part.
`void` `setFileName​(java.lang.String filename)` Set the filename associated with this body part, if possible.
`void` `setHeader​(java.lang.String name, java.lang.String value)` Set the value for this header_name.
`protected void` `updateHeaders()` Examine the content of this body part and update the appropriate MIME headers.

### Methods inherited from class javax.mail.internet.MimeBodyPart

`attachFile, attachFile, attachFile, attachFile, getContent, getContentLanguage, getHeader, getInputStream, getRawInputStream, isMimeType, saveFile, saveFile, setContentID, setContentLanguage, setDescription, setText, setText, setText, writeTo`

### Methods inherited from class javax.mail.BodyPart

`getParent`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IMAPBodyPart

    protected IMAPBodyPart​(BODYSTRUCTURE bs,
                           java.lang.String sid,
                           IMAPMessage message)

### Method Detail

#### updateHeaders

    protected void updateHeaders()

Description copied from class: `MimeBodyPart`
Examine the content of this body part and update the appropriate MIME headers. Typical headers that get set here are `Content-Type` and `Content-Transfer-Encoding`. Headers might need to be updated in two cases:
- A message being crafted by a mail application will certainly need to activate this method at some point to fill up its internal headers.
- A message read in from a Store will have obtained all its headers from the store, and so doesn't need this. However, if this message is editable and if any edits have been made to either the content or message structure, we might need to resync our headers.
In both cases this method is typically called by the `Message.saveChanges` method.

If the `MimeBodyPart.cachedContent` field is not null (that is, it references a Multipart or Message object), then that object is used to set a new DataHandler, any stream data used to create this object is discarded, and the `MimeBodyPart.cachedContent` field is cleared.

Overrides:
  `updateHeaders` in class `MimeBodyPart`

#### getSize

    public int getSize()
                throws MessagingException

Description copied from class: `MimeBodyPart`
Return the size of the content of this body part in bytes. Return -1 if the size cannot be determined.

Note that this number may not be an exact measure of the content size and may or may not account for any transfer encoding of the content.

This implementation returns the size of the `content` array (if not null), or, if `contentStream` is not null, and the `available` method returns a positive number, it returns that number as the size. Otherwise, it returns -1.

Specified by:
  `getSize` in interface `Part`
Overrides:
  `getSize` in class `MimeBodyPart`
Returns:
  size in bytes, or -1 if not known
Throws:
  `MessagingException` - for failures

#### getLineCount

    public int getLineCount()
                     throws MessagingException

Description copied from class: `MimeBodyPart`
Return the number of lines for the content of this Part. Return -1 if this number cannot be determined.

Note that this number may not be an exact measure of the content length and may or may not account for any transfer encoding of the content.

This implementation returns -1.

Specified by:
  `getLineCount` in interface `Part`
Overrides:
  `getLineCount` in class `MimeBodyPart`
Returns:
  number of lines, or -1 if not known
Throws:
  `MessagingException` - for failures

#### getContentType

    public java.lang.String getContentType()
                                    throws MessagingException

Description copied from class: `MimeBodyPart`
Returns the value of the RFC 822 "Content-Type" header field. This represents the content type of the content of this body part. This value must not be null. If this field is unavailable, "text/plain" should be returned.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getContentType` in interface `Part`
Overrides:
  `getContentType` in class `MimeBodyPart`
Returns:
  Content-Type of this body part
Throws:
  `MessagingException` - for failures
See Also:
  `DataHandler`

#### getDisposition

    public java.lang.String getDisposition()
                                    throws MessagingException

Description copied from class: `MimeBodyPart`
Returns the disposition from the "Content-Disposition" header field. This represents the disposition of this part. The disposition describes how the part should be presented to the user.

If the Content-Disposition field is unavailable, null is returned.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getDisposition` in interface `Part`
Overrides:
  `getDisposition` in class `MimeBodyPart`
Returns:
  disposition of this part, or null if unknown
Throws:
  `MessagingException` - for failures
See Also:
  `MimeBodyPart.headers`

#### setDisposition

    public void setDisposition​(java.lang.String disposition)
                        throws MessagingException

Description copied from class: `MimeBodyPart`
Set the disposition in the "Content-Disposition" header field of this body part. If the disposition is null, any existing "Content-Disposition" header field is removed.

Specified by:
  `setDisposition` in interface `Part`
Overrides:
  `setDisposition` in class `MimeBodyPart`
Parameters:
  `disposition` - disposition of this part
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `MessagingException` - for other failures
See Also:
  `Part.ATTACHMENT`, `Part.INLINE`, `Part.setFileName(java.lang.String)`

#### getEncoding

    public java.lang.String getEncoding()
                                 throws MessagingException

Description copied from class: `MimeBodyPart`
Returns the content transfer encoding from the "Content-Transfer-Encoding" header field. Returns `null` if the header is unavailable or its value is absent.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getEncoding` in interface `MimePart`
Overrides:
  `getEncoding` in class `MimeBodyPart`
Returns:
  content-transfer-encoding
Throws:
  `MessagingException` - for failures
See Also:
  `MimeBodyPart.headers`

#### getContentID

    public java.lang.String getContentID()
                                  throws MessagingException

Description copied from class: `MimeBodyPart`
Returns the value of the "Content-ID" header field. Returns `null` if the field is unavailable or its value is absent.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getContentID` in interface `MimePart`
Overrides:
  `getContentID` in class `MimeBodyPart`
Returns:
  content-ID
Throws:
  `MessagingException` - for failures

#### getContentMD5

    public java.lang.String getContentMD5()
                                   throws MessagingException

Description copied from class: `MimeBodyPart`
Return the value of the "Content-MD5" header field. Returns `null` if this field is unavailable or its value is absent.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getContentMD5` in interface `MimePart`
Overrides:
  `getContentMD5` in class `MimeBodyPart`
Returns:
  content-MD5
Throws:
  `MessagingException` - for failures

#### setContentMD5

    public void setContentMD5​(java.lang.String md5)
                       throws MessagingException

Description copied from class: `MimeBodyPart`
Set the "Content-MD5" header field of this body part.

Specified by:
  `setContentMD5` in interface `MimePart`
Overrides:
  `setContentMD5` in class `MimeBodyPart`
Parameters:
  `md5` - the MD5 value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `MessagingException`

#### getDescription

    public java.lang.String getDescription()
                                    throws MessagingException

Description copied from class: `MimeBodyPart`
Returns the "Content-Description" header field of this body part. This typically associates some descriptive information with this part. Returns null if this field is unavailable or its value is absent.

If the Content-Description field is encoded as per RFC 2047, it is decoded and converted into Unicode. If the decoding or conversion fails, the raw data is returned as is.

This implementation uses `getHeader(name)` to obtain the requisite header field.

Specified by:
  `getDescription` in interface `Part`
Overrides:
  `getDescription` in class `MimeBodyPart`
Returns:
  content description
Throws:
  `MessagingException` - for failures

#### setDescription

    public void setDescription​(java.lang.String description,
                               java.lang.String charset)
                        throws MessagingException

Description copied from class: `MimeBodyPart`
Set the "Content-Description" header field for this body part. If the description parameter is `null`, then any existing "Content-Description" fields are removed.

If the description contains non US-ASCII characters, it will be encoded using the specified charset. If the description contains only US-ASCII characters, no encoding is done and it is used as is.

Note that if the charset encoding process fails, a MessagingException is thrown, and an UnsupportedEncodingException is included in the chain of nested exceptions within the MessagingException.

Overrides:
  `setDescription` in class `MimeBodyPart`
Parameters:
  `description` - Description
  `charset` - Charset for encoding
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `MessagingException` - otherwise; an UnsupportedEncodingException may be included in the exception chain if the charset conversion fails.

#### getFileName

    public java.lang.String getFileName()
                                 throws MessagingException

Description copied from class: `MimeBodyPart`
Get the filename associated with this body part.

Returns the value of the "filename" parameter from the "Content-Disposition" header field of this body part. If its not available, returns the value of the "name" parameter from the "Content-Type" header field of this body part. Returns `null` if both are absent.

If the `mail.mime.decodefilename` System property is set to true, the `MimeUtility.decodeText` method will be used to decode the filename. While such encoding is not supported by the MIME spec, many mailers use this technique to support non-ASCII characters in filenames. The default value of this property is false.

Specified by:
  `getFileName` in interface `Part`
Overrides:
  `getFileName` in class `MimeBodyPart`
Returns:
  filename
Throws:
  `MessagingException` - for failures

#### setFileName

    public void setFileName​(java.lang.String filename)
                     throws MessagingException

Description copied from class: `MimeBodyPart`
Set the filename associated with this body part, if possible.

Sets the "filename" parameter of the "Content-Disposition" header field of this body part. For compatibility with older mailers, the "name" parameter of the "Content-Type" header is also set.

If the `mail.mime.encodefilename` System property is set to true, the `MimeUtility.encodeText` method will be used to encode the filename. While such encoding is not supported by the MIME spec, many mailers use this technique to support non-ASCII characters in filenames. The default value of this property is false.

Specified by:
  `setFileName` in interface `Part`
Overrides:
  `setFileName` in class `MimeBodyPart`
Parameters:
  `filename` - the file name
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `MessagingException` - for other failures

#### getContentStream

    protected java.io.InputStream getContentStream()
                                            throws MessagingException

Description copied from class: `MimeBodyPart`
Produce the raw bytes of the content. This method is used when creating a DataHandler object for the content. Subclasses that can provide a separate input stream for just the Part content might want to override this method.

Overrides:
  `getContentStream` in class `MimeBodyPart`
Returns:
  an InputStream containing the raw bytes
Throws:
  `MessagingException` - for failures
See Also:
  `MimeBodyPart.content`, `MimeMessage.getContentStream()`

#### getMimeStream

    public java.io.InputStream getMimeStream()
                                      throws MessagingException

Return the MIME format stream corresponding to this message part.

Specified by:
  `getMimeStream` in interface `ReadableMime`
Returns:
  the MIME format stream
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.4.5

#### getDataHandler

    public javax.activation.DataHandler getDataHandler()
                                                throws MessagingException

Description copied from class: `MimeBodyPart`
Return a DataHandler for this body part's content.

The implementation provided here works just like the the implementation in MimeMessage.

Specified by:
  `getDataHandler` in interface `Part`
Overrides:
  `getDataHandler` in class `MimeBodyPart`
Returns:
  DataHandler for the content
Throws:
  `MessagingException` - for failures
See Also:
  `MimeMessage.getDataHandler()`

#### setDataHandler

    public void setDataHandler​(javax.activation.DataHandler content)
                        throws MessagingException

Description copied from class: `MimeBodyPart`
This method provides the mechanism to set this body part's content. The given DataHandler object should wrap the actual content.

Specified by:
  `setDataHandler` in interface `Part`
Overrides:
  `setDataHandler` in class `MimeBodyPart`
Parameters:
  `content` - The DataHandler for the content
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures

#### setContent

    public void setContent​(java.lang.Object o,
                           java.lang.String type)
                    throws MessagingException

Description copied from class: `MimeBodyPart`
A convenience method for setting this body part's content.

The content is wrapped in a DataHandler object. Note that a DataContentHandler class for the specified type should be available to the JavaMail implementation for this to work right. That is, to do `setContent(foobar, "application/x-foobar")`, a DataContentHandler for "application/x-foobar" should be installed. Refer to the Java Activation Framework for more information.

Specified by:
  `setContent` in interface `Part`
Overrides:
  `setContent` in class `MimeBodyPart`
Parameters:
  `o` - the content object
  `type` - Mime type of the object
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures

#### setContent

    public void setContent​(Multipart mp)
                    throws MessagingException

Description copied from class: `MimeBodyPart`
This method sets the body part's content to a Multipart object.

Specified by:
  `setContent` in interface `Part`
Overrides:
  `setContent` in class `MimeBodyPart`
Parameters:
  `mp` - The multipart object that is the Message's content
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures

#### getHeader

    public java.lang.String[] getHeader​(java.lang.String name)
                                 throws MessagingException

Description copied from class: `MimeBodyPart`
Get all the headers for this header_name. Note that certain headers may be encoded as per RFC 2047 if they contain non US-ASCII characters and these should be decoded.

Specified by:
  `getHeader` in interface `Part`
Overrides:
  `getHeader` in class `MimeBodyPart`
Parameters:
  `name` - name of header
Returns:
  array of headers
Throws:
  `MessagingException` - for failures
See Also:
  `MimeUtility`

#### setHeader

    public void setHeader​(java.lang.String name,
                          java.lang.String value)
                   throws MessagingException

Description copied from class: `MimeBodyPart`
Set the value for this header_name. Replaces all existing header values with this new value. Note that RFC 822 headers must contain only US-ASCII characters, so a header that contains non US-ASCII characters must be encoded as per the rules of RFC 2047.

Specified by:
  `setHeader` in interface `Part`
Overrides:
  `setHeader` in class `MimeBodyPart`
Parameters:
  `name` - header name
  `value` - header value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures
See Also:
  `MimeUtility`

#### addHeader

    public void addHeader​(java.lang.String name,
                          java.lang.String value)
                   throws MessagingException

Description copied from class: `MimeBodyPart`
Add this value to the existing values for this header_name. Note that RFC 822 headers must contain only US-ASCII characters, so a header that contains non US-ASCII characters must be encoded as per the rules of RFC 2047.

Specified by:
  `addHeader` in interface `Part`
Overrides:
  `addHeader` in class `MimeBodyPart`
Parameters:
  `name` - header name
  `value` - header value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures
See Also:
  `MimeUtility`

#### removeHeader

    public void removeHeader​(java.lang.String name)
                      throws MessagingException

Description copied from class: `MimeBodyPart`
Remove all headers with this name.

Specified by:
  `removeHeader` in interface `Part`
Overrides:
  `removeHeader` in class `MimeBodyPart`
Parameters:
  `name` - the name of this header
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `MessagingException` - for other failures

#### getAllHeaders

    public java.util.Enumeration<Header> getAllHeaders()
                                                throws MessagingException

Description copied from class: `MimeBodyPart`
Return all the headers from this Message as an Enumeration of Header objects.

Specified by:
  `getAllHeaders` in interface `Part`
Overrides:
  `getAllHeaders` in class `MimeBodyPart`
Returns:
  enumeration of Header objects
Throws:
  `MessagingException` - for failures

#### getMatchingHeaders

    public java.util.Enumeration<Header> getMatchingHeaders​(java.lang.String[] names)
                                                     throws MessagingException

Description copied from class: `MimeBodyPart`
Return matching headers from this Message as an Enumeration of Header objects.

Specified by:
  `getMatchingHeaders` in interface `Part`
Overrides:
  `getMatchingHeaders` in class `MimeBodyPart`
Parameters:
  `names` - the headers to match
Returns:
  enumeration of Header objects
Throws:
  `MessagingException` - for failures

#### getNonMatchingHeaders

    public java.util.Enumeration<Header> getNonMatchingHeaders​(java.lang.String[] names)
                                                        throws MessagingException

Description copied from class: `MimeBodyPart`
Return non-matching headers from this Message as an Enumeration of Header objects.

Specified by:
  `getNonMatchingHeaders` in interface `Part`
Overrides:
  `getNonMatchingHeaders` in class `MimeBodyPart`
Parameters:
  `names` - the headers to not match
Returns:
  enumeration of Header objects
Throws:
  `MessagingException` - for failures

#### addHeaderLine

    public void addHeaderLine​(java.lang.String line)
                       throws MessagingException

Description copied from class: `MimeBodyPart`
Add a header line to this body part

Specified by:
  `addHeaderLine` in interface `MimePart`
Overrides:
  `addHeaderLine` in class `MimeBodyPart`
Parameters:
  `line` - the line to add
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `MessagingException` - for other failures

#### getAllHeaderLines

    public java.util.Enumeration<java.lang.String> getAllHeaderLines()
                                                              throws MessagingException

Description copied from class: `MimeBodyPart`
Get all header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header line, containing both the "name" and "value" field.

Specified by:
  `getAllHeaderLines` in interface `MimePart`
Overrides:
  `getAllHeaderLines` in class `MimeBodyPart`
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures

#### getMatchingHeaderLines

    public java.util.Enumeration<java.lang.String> getMatchingHeaderLines​(java.lang.String[] names)
                                                                   throws MessagingException

Description copied from class: `MimeBodyPart`
Get matching header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header line, containing both the "name" and "value" field.

Specified by:
  `getMatchingHeaderLines` in interface `MimePart`
Overrides:
  `getMatchingHeaderLines` in class `MimeBodyPart`
Parameters:
  `names` - the headers to return
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures

#### getNonMatchingHeaderLines

    public java.util.Enumeration<java.lang.String> getNonMatchingHeaderLines​(java.lang.String[] names)
                                                                      throws MessagingException

Description copied from class: `MimeBodyPart`
Get non-matching header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header line, containing both the "name" and "value" field.

Specified by:
  `getNonMatchingHeaderLines` in interface `MimePart`
Overrides:
  `getNonMatchingHeaderLines` in class `MimeBodyPart`
Parameters:
  `names` - the headers to not return
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures